#ifndef CMAP_H
#define CMAP_H

#include <QImage>
#include <QColor>
#include "system/cmaths.h"

#define TILE_SIZE   32

enum EWallSide
{
    eWallSideUp = 0,
    eWallSideDown,
    eWallSideLeft,
    eWallSideRight,
    eWallSideMax
};

//---------------------------------------------------------------------------------------------
class CWall
{
public:
    CWall();

    uint8_t mType;
};

//---------------------------------------------------------------------------------------------
class CTile
{
public:
    CTile();

    CWall   mWalls[eWallSideMax];
    uint8_t mType;
};

//---------------------------------------------------------------------------------------------
class CMap
{
public:
    CMap();
    ~CMap();

    void    resize();

    void    setTile(CVec2 pos, uint8_t type);
    void    setWall(CVec2 pos, EWallSide side, uint8_t type);
    bool    isLoaded();

    CTile*  getTile(CVec2 pos);

    CVec2   mSize;

private:
    CTile*  mTiles;
};

extern CMap  map;

#endif // CMAP_H
